//DataGridComboBoxColumn Class for C#
//Version 1.0
//쐬ҁFǂڂI http://dobon.net

using System;
using System.Data;
using System.Windows.Forms;
using System.Drawing;

namespace Dobon.Samples.Forms
{
	public class DataGridComboBoxColumn : DataGridTextBoxColumn
	{
		private DataGridComboBox _comboBox;
		private CurrencyManager _sorce;
		private int _rowNumber;
		private bool _editing;

		/// <summary>
		/// DataGridComboBoxColumñRXgN^
		/// </summary>
		/// <param name="dataSource">ComboBoxDataSource</param>
		/// <param name="displayMember">ComboBoxDisplayMember</param>
		/// <param name="valueMember">ComboBoxValueMember</param>
		public DataGridComboBoxColumn(DataView dataSource, 
			string displayMember, 
			string valueMember)
		{
			//ݒ
			_sorce = null;
			_editing = false;

			//DataGridComboBox̍쐬
			_comboBox = new DataGridComboBox();
			//ComboBox̐ݒ
			_comboBox.DropDownStyle = ComboBoxStyle.DropDownList;
			_comboBox.Visible = false;
			//f[^\[X̐ݒ
			_comboBox.DataSource = dataSource;
			_comboBox.DisplayMember = displayMember;
			_comboBox.ValueMember = valueMember;

			//Cxgnh
			_comboBox.Leave += new EventHandler(_comboBox_Leave);
			_comboBox.SelectionChangeCommitted += 
				new EventHandler(_comboBox_SelectionChangeCommitted);
		}

		//vpeB
		/// <summary>
		/// ǗĂ ComboBox Rg[擾܂B
		/// </summary>
		public DataGridComboBox ComboBox
		{
			get
			{
				return _comboBox;
			}
		}

		//ComboBoxtH[JXꂽ
		private void _comboBox_Leave(object sender, EventArgs e)
		{
			if (_editing)
			{
				//ComboBoxҏWƂ
				_editing = false;
				//s̒lXV
				SetColumnValueAtRow(
					_sorce, _rowNumber, _comboBox.Text);
				Invalidate();
			}
			//ComboBoxB
			_comboBox.Visible = false;
			//DataGrid̃XN[Cxgߑ
			DataGridTableStyle.DataGrid.Scroll += 
				new EventHandler(DataGrid_Scroll);
		}

		//DataGridXN[
		private void DataGrid_Scroll(object sender, EventArgs e)
		{
			//ComboBox
			if (_comboBox.Visible)
				_comboBox.Visible = false;
		}

		//ComboBoxőIڂύXāA̕ύXR~bgꂽ
		private void _comboBox_SelectionChangeCommitted(
			object sender, EventArgs e)
		{
			_editing = true;
			//DataGridɗ񂪕ҏWJnꂽƂm点
			base.ColumnStartedEditing((Control) sender);
		}

		//s̍ŏ̍
		protected override int GetMinimumHeight()
		{
			return _comboBox.PreferredHeight;
		}

		//ComboBoxDataGridControl.ControlCollectionɒǉ
		protected override void SetDataGridInColumn(DataGrid value)
		{
			base.SetDataGridInColumn(value);
			_comboBox.Parent = (Control) value;
		}

		//񂪊ǗĂRg[ւ̃tH[JX
		//Kv邱Ƃɒʒm
		protected override void ConcedeFocus()
		{
			base.ConcedeFocus();
			_comboBox.Visible = false;
		}

		//ҏW邽߂ɃZ
		protected override void Edit(CurrencyManager source,
			int rowNum, Rectangle bounds, bool readOnly,
			string instantText, bool cellIsVisible)
		{
			//{NXEditĂяo
			base.Edit(source, rowNum, bounds, readOnly, instantText,
				cellIsVisible);
			//TextBox
			this.TextBox.Visible = false;
			
			//l̕ۑ
			_rowNumber = rowNum;
			_sorce = source;

			//\ComboBox̐ݒ
			_comboBox.Bounds = bounds;
			_comboBox.RightToLeft =
				this.DataGridTableStyle.DataGrid.RightToLeft;
			//\Aǂݎp̂Ƃ́AComboBox\Ȃ
			if (cellIsVisible && !readOnly)
			{
				//ComboBox\
				_comboBox.Visible = true;
				_comboBox.BringToFront();
				_comboBox.Focus();
			}

			//Iڂ̕ύX
			//ComboBox\OɍsƁA
			//VsŒlύXssN
			_comboBox.SelectedIndex =
				_comboBox.FindStringExact(this.TextBox.Text);

			//DataGrid̃XN[Cxgߑ
			DataGridTableStyle.DataGrid.Scroll +=
				new EventHandler(DataGrid_Scroll);
		}

		//ҏWvV[W
		protected override bool Commit(
			CurrencyManager dataSource, int rowNum)
		{
			if (_editing)
			{
				//ҏŴƂ́ArowNums̒lݒ肷
				_editing = false;
				SetColumnValueAtRow(
					dataSource, rowNum, _comboBox.Text);
			}

			return true;
		}

		//w肵s̒lݒ
		protected override void SetColumnValueAtRow(
			CurrencyManager source, int rowNum, object value)
		{
			//ValueMember̒lݒ肷
			base.SetColumnValueAtRow(
				source, rowNum, _comboBox.FindValueMember(value));
		}

		//w肵s̒l擾
		protected override object GetColumnValueAtRow(
			CurrencyManager source, int rowNum)
		{
			object val = base.GetColumnValueAtRow(source, rowNum);
			//DisplayMember̒lԂ
			return _comboBox.FindDisplayMember(val);
		}

	}

	public class DataGridComboBox: System.Windows.Forms.ComboBox
	{
		private const int WM_KEYUP = 0x101;

		protected override void WndProc(
			ref System.Windows.Forms.Message theMessage)
		{
			//L[𖳌ɂ
			if (theMessage.Msg == WM_KEYUP)
			{
				return;
			}
			base.WndProc(ref theMessage);
		}

		/// <summary>
		/// DisplayMemberValueMember̒lT
		/// </summary>
		/// <param name="display">TDisplayMemberl</param>
		/// <returns>ValueMemberl</returns>
		public object FindValueMember(object display)
		{
			DataView dv = (DataView) DataSource;
			int rowCount = dv.Count;

			//[vĒT
			object disp;
			for (int i = 0; i < rowCount; i++)
			{
				disp = dv[i][DisplayMember];
				//
				if (display.Equals(disp))
				{
					return dv[i][ValueMember];
				}
			}
			//Ȃ
			return DBNull.Value;
		}
		
		/// <summary>
		/// ValueMemberDisplayMember̒lT
		/// </summary>
		/// <param name="value">TValueMemberl</param>
		/// <returns>DisplayMemberl</returns>
		public object FindDisplayMember(object value)
		{
			DataView dv = (DataView) DataSource;
			int rowCount = dv.Count;

			//[vĒT
			object val;
			for (int i = 0; i < rowCount; i++)
			{
				val = dv[i][ValueMember];
				//
				if (value.Equals(val))
				{
					return dv[i][DisplayMember];
				}
			}
			//Ȃ
			return DBNull.Value;
		}
	}
}
